Video for Linux Two API Specification: Revision 0.24
Prev |  | Next

# ioctl VIDIOC_G_CROP, VIDIOC_S_CROP

## Name

VIDIOC_G_CROP, VIDIOC_S_CROP -- Get or set the current cropping rectangle

## Synopsis

``int ioctl`(int fd, int request, struct v4l2_crop *argp);`

``int ioctl`(int fd, int request, const struct v4l2_crop *argp);`

## Arguments

`fd`

  File descriptor returned by `open()`.

`request`

  VIDIOC_G_CROP, VIDIOC_S_CROP

`argp`

## Description

To query the cropping rectangle size and position applications set the `type` field of a `v4l2_crop` structure to the respective buffer (stream) type and call the `VIDIOC_G_CROP` ioctl with a pointer to this structure. The driver fills the rest of the structure or returns the EINVAL error code if cropping is not supported.

To change the cropping rectangle applications initialize the `type` and struct v4l2_rect substructure named `c` of a v4l2_crop structure and call the `VIDIOC_S_CROP` ioctl with a pointer to this structure.

The driver first adjusts the requested dimensions against hardware limits, i. e. the bounds given by the capture/output window, and it rounds to the closest possible values of horizontal and vertical offset, width and height. In particular the driver must round the vertical offset of the cropping rectangle to frame lines modulo two, such that the field order cannot be confused.

Second the driver adjusts the image size (the opposite rectangle of the scaling process, source or target depending on the data direction) to the closest size possible while maintaining the current horizontal and vertical scaling factor.

Finally the driver programs the hardware with the actual cropping and image parameters. `VIDIOC_S_CROP` is a write-only ioctl, it does not return the actual parameters. To query them applications must call `VIDIOC_G_CROP` and `VIDIOC_G_FMT`. When the parameters are unsuitable the application may modify the cropping or image parameters and repeat the cycle until satisfactory parameters have been negotiated.

When cropping is not supported then no parameters are changed and `VIDIOC_S_CROP` returns the EINVAL error code.

Table 1. struct `v4l2_crop`

enum v4l2_buf_type | `type` | Type of the data stream, set by the application. Only these types are valid here: `V4L2_BUF_TYPE_VIDEO_CAPTURE`, `V4L2_BUF_TYPE_VIDEO_OUTPUT`, `V4L2_BUF_TYPE_VIDEO_OVERLAY`, and custom (driver defined) types with code `V4L2_BUF_TYPE_PRIVATE` and higher.
struct v4l2_rect | `c` | Cropping rectangle. The same co-ordinate system as for struct v4l2_cropcap `bounds` is used.

## Return Value

On success 0 is returned, on error -1 and the `errno` variable is set appropriately:

EINVAL

  Cropping is not supported.

Prev | Home | Next
ioctl VIDIOC_G_CHIP_IDENT | Up | ioctl VIDIOC_G_CTRL, VIDIOC_S_CTRL